import os
import sys
import traceback
from termcolor import cprint
from functools import wraps


def unwrap(func):
    while hasattr(func, '__wrapped__'):
        func = func.__wrapped__
    return func


def watch(func):
    @wraps(func)
    def wrapper(*args, **kwargs): 
        print('\n')
        func_name_stdout = f'{func.__code__.co_filename} -> {func.__name__}: Line number {func.__code__.co_firstlineno}'
        cprint(func_name_stdout, 'blue', 'on_white')  

        args_stdout = ""
        if args: 
            args_stdout += f"args: {args}"
        if kwargs: 
            args_stdout += f"kwargs: {kwargs}"  
        if args_stdout:          
            cprint(args_stdout, 'blue', 'on_white')   

        response = None
        try:
            response = func(*args, **kwargs)                            
        except Exception as e:
            traceback.print_exc()
        
        return response 
    return wrapper
